using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services.Protocols;
using MarcusWS_Sample.AlertManagerV2;

namespace MarcusWS_Sample
{
    class AlertManager
    {
        public static DWHeader GetAlertManagerHeader(string token)
        {
            DWHeader header = new DWHeader();
            SenderInfo si = new SenderInfo();
            si.ApplicationID = "SampleClient2"; //user supplied value for tracking

            Credentials cred = new Credentials();
            cred.AuthToken = token;
            si.Credentials = cred;
            header.SenderInfo = si;

            return header;
        }

        public static int CreateAlertArriveLocation(String authtoken, CreateAlertArriveLocationRequest messagePart)
        {
            AlertManagerV2Port service = new AlertManagerV2Port();
            service.DWHeaderValue = GetAlertManagerHeader(authtoken);

            CustomDays customDays = new CustomDays();
            customDays.WeekdayList = new WeekDayChoices[2];
            customDays.WeekdayList[0] = WeekDayChoices.Mo;
            customDays.WeekdayList[1] = WeekDayChoices.Tu;
            ActiveDays activeDays = new ActiveDays();
            activeDays.Item = customDays;
            messagePart.ActiveDays = activeDays;

            StringList stringList = new StringList();
            stringList.Entry = new string[1];
            stringList.Entry[0] = "test@test.com";
            messagePart.Emails = stringList;
            messagePart.UserId = "80338";

            AppliesTo appliesTo = new AppliesTo();
            StringList hardwareIdList = new StringList();
            hardwareIdList.Entry = new string[1];
            hardwareIdList.Entry[0] = "5003333333";
            appliesTo.Item = hardwareIdList;
            appliesTo.ItemElementName = ItemChoiceType.SelectedMobiles;
            messagePart.AppliesTo = appliesTo;

            AllOrBetweenTimes allOrBetweenTimes = new AllOrBetweenTimes();
            allOrBetweenTimes.Item = new TwentyFourHoursPerDay();
            messagePart.AllOrBetweenTimes = allOrBetweenTimes;

            messagePart.ArriveLocation = "500";

            CUDResponse resp = service.createAlertDefinitionArriveLocation(messagePart);
            if (resp != null)
            {
                String result = resp.Result;
                if (result == null)
                    return -1;
                return System.Convert.ToInt32(result, 10); ;
            }
            return -1;
        }
    }
}
